

type SoftwareProject{
    id: ID!
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

type GeneralProjectProcess{
    id: ID!
    name:String!
    description:String!
    startDate:String!
    endDate:String!
    externalId:String!
    internalId:String!
}

type SpecificProjectProcess{
    id: ID!
    name:String!
    description:String!
    startDate:String!
    endDate:String!
    externalId:String!
    internalId:String!
}

type Activity{
    id: ID!
    name:String!
    description:String!
    startDate:String!
    endDate:String!
    externalId:String!
    internalId:String!
}

type ProjectStakeholder{
    id: ID!
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

type ProjectTeamStakeholder{
    id: ID!
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

type ProjectPersonStakeholder{
    id: ID!
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

type Artifact{
    id: ID!
    name:String!
    description:String!
    startDate:String!
    endDate:String!
    externalId:String!
    internalId:String!
}



input SoftwareProjectInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input GeneralProjectProcessInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input SpecificProjectProcessInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input ActivityInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input ProjectStakeholderInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input ProjectTeamStakeholderInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input ProjectPersonStakeholderInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}

input ArtifactInput{
  name:String!
  description:String!
  startDate:String!
  endDate:String!
  externalId:String!
  internalId:String!
}


type Query{

  findAllSoftwareProjects:[SoftwareProject]
  findAllGeneralProjectProcesss:[GeneralProjectProcess]
  findAllSpecificProjectProcesss:[SpecificProjectProcess]
  findAllActivitys:[Activity]
  findAllProjectStakeholders:[ProjectStakeholder]
  findAllProjectTeamStakeholders:[ProjectTeamStakeholder]
  findAllProjectPersonStakeholders:[ProjectPersonStakeholder]
  findAllArtifacts:[Artifact]

  findByIDSoftwareProject (id: ID!):SoftwareProject
  findByIDGeneralProjectProcess (id: ID!):GeneralProjectProcess
  findByIDSpecificProjectProcess (id: ID!):SpecificProjectProcess
  findByIDActivity (id: ID!):Activity
  findByIDProjectStakeholder (id: ID!):ProjectStakeholder
  findByIDProjectTeamStakeholder (id: ID!):ProjectTeamStakeholder
  findByIDProjectPersonStakeholder (id: ID!):ProjectPersonStakeholder
  findByIDArtifact (id: ID!):Artifact
}

type Mutation{

  createSoftwareProject(input: SoftwareProjectInput):SoftwareProject
  createGeneralProjectProcess(input: GeneralProjectProcessInput):GeneralProjectProcess
  createSpecificProjectProcess(input: SpecificProjectProcessInput):SpecificProjectProcess
  createActivity(input: ActivityInput):Activity
  createProjectStakeholder(input: ProjectStakeholderInput):ProjectStakeholder
  createProjectTeamStakeholder(input: ProjectTeamStakeholderInput):ProjectTeamStakeholder
  createProjectPersonStakeholder(input: ProjectPersonStakeholderInput):ProjectPersonStakeholder
  createArtifact(input: ArtifactInput):Artifact

  deleteSoftwareProject (id: ID!):SoftwareProject
  deleteGeneralProjectProcess (id: ID!):GeneralProjectProcess
  deleteSpecificProjectProcess (id: ID!):SpecificProjectProcess
  deleteActivity (id: ID!):Activity
  deleteProjectStakeholder (id: ID!):ProjectStakeholder
  deleteProjectTeamStakeholder (id: ID!):ProjectTeamStakeholder
  deleteProjectPersonStakeholder (id: ID!):ProjectPersonStakeholder
  deleteArtifact (id: ID!):Artifact

  updateSoftwareProject (id: ID!, input: SoftwareProjectInput):SoftwareProject
  updateGeneralProjectProcess (id: ID!, input: GeneralProjectProcessInput):GeneralProjectProcess
  updateSpecificProjectProcess (id: ID!, input: SpecificProjectProcessInput):SpecificProjectProcess
  updateActivity (id: ID!, input: ActivityInput):Activity
  updateProjectStakeholder (id: ID!, input: ProjectStakeholderInput):ProjectStakeholder
  updateProjectTeamStakeholder (id: ID!, input: ProjectTeamStakeholderInput):ProjectTeamStakeholder
  updateProjectPersonStakeholder (id: ID!, input: ProjectPersonStakeholderInput):ProjectPersonStakeholder
  updateArtifact (id: ID!, input: ArtifactInput):Artifact
}
